# Class AccessRowSequence

java.lang.Object
uk.ac.starlink.table.AccessRowSequence

All Implemented Interfaces:
  `Closeable, AutoCloseable, RowData, RowSequence, uk.ac.starlink.util.Sequence`

public class AccessRowSequence extends Object implements RowSequence
RowSequence implementation based on a RowAccess.

Since:
  24 Jul 2020
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`AccessRowSequence(RowAccess racc, long nrow)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
Indicates that this sequence will not be required any more.
`static AccessRowSequence`
`createInstance(StarTable table)`
Constructs an AccessRowSequence based on a given table.
`Object`
`getCell(int icol)`
Returns the contents of a cell in the current row.
`Object[]`
`getRow()`
Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table.
`boolean`
`next()`
Attempts to advance the current row to the next one.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### AccessRowSequence

public AccessRowSequence(RowAccess racc, long nrow)
Constructor.

Parameters:
  `racc` - row access providing data access
  `nrow` - number of rows

## Method Details

### next

public boolean next() throws IOException
Description copied from interface: `RowSequence`
Attempts to advance the current row to the next one. If `true` is returned the attempt has been successful, and if `false` is returned there are no more rows in this sequence. Since the initial position of a RowSequence is before the first row, this method must be called before current row data can be accessed using the `RowSequence.getCell(int)` or `RowSequence.getRow()` methods.

Specified by:
  `next` in interface `RowSequence`
Specified by:
  `next` in interface `uk.ac.starlink.util.Sequence`
Returns:
  `true` iff this sequence has been advanced to the next row
Throws:
  `IOException` - if there is some error

### getCell

public Object getCell(int icol) throws IOException
Description copied from interface: `RowSequence`
Returns the contents of a cell in the current row. The class of the returned object should be the same as, or a subclass of, the class returned by `getColumnInfo(icol).getContentClass()`. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).

Specified by:
  `getCell` in interface `RowData`
Specified by:
  `getCell` in interface `RowSequence`
Parameters:
  `icol` - column index
Returns:
  the contents of cell `icol` in the current row
Throws:
  `IOException` - if there is an error reading the data

### getRow

public Object[] getRow() throws IOException
Description copied from interface: `RowSequence`
Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).

Specified by:
  `getRow` in interface `RowData`
Specified by:
  `getRow` in interface `RowSequence`
Returns:
  an array of the objects in each cell in row `irow`
Throws:
  `IOException` - if there is an error reading the data

### close

public void close() throws IOException
Description copied from interface: `RowSequence`
Indicates that this sequence will not be required any more. This should release resources associated with this object. The effect of calling any of the other methods following a `close` is undefined.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `RowSequence`
Throws:
  `IOException`

### createInstance

public static AccessRowSequence createInstance(StarTable table) throws IOException
Constructs an AccessRowSequence based on a given table.

Parameters:
  `table` - table
Returns:
  new row access
Throws:
  `IOException`